---
title: Xamarin.Android warning XA4231
description: XA4231 warning code
ms.date: 04/23/2020
---
# Xamarin.Android warning XA4231

## Example messages

```
warning XA4231: The Android class parser value 'jar2xml' is deprecated and will be removed in a future version of Xamarin.Android. Update the project properties to use 'class-parse'.
```

## Issue

The Android class parser `jar2xml` has been deprecated.

## Solution

To resolve this warning, update the **Android Class Parser** setting in the Visual
Studio project property pages or the **.jar file parser** setting in Visual
Studio for Mac to **class-parse**.  This corresponds to the `class-parse` value
for the `AndroidClassParser` MSBuild property in the _.csproj_ file:

```xml
<PropertyGroup>
  <AndroidClassParser>class-parse</AndroidClassParser>
</PropertyGroup>
```
